#ifndef APPINST_DATA_COLLECTION_H_
#define APPINST_DATA_COLLECTION_H_

/* ------------------------------------------
 ObservableScope
 ------------------------------------------ */
const AppInst_STRING8_t
AppInst_ObservableScope_get_name(
		AppInst_ObservableScope *self);

AppInst_InstrumentationService*
AppInst_ObservableScope_get_service(
		AppInst_ObservableScope *self);

AppInst_ReturnCode_t
AppInst_ObservableScope_enable_data_collection(
		AppInst_ObservableScope *self);

AppInst_ReturnCode_t
AppInst_ObservableScope_disable_data_collection(
		AppInst_ObservableScope *self);

AppInst_BOOL_t
AppInst_ObservableScope_is_data_collection_enabled(
		AppInst_ObservableScope *self);

AppInst_ObservableObject*
AppInst_ObservableScope_create_observable_object(
		AppInst_ObservableScope *self,
		const AppInst_STRING8_t name,
		const AppInst_ObservableObjectProperties_t *properties,
		AppInst_ReturnCode_t *retcode_out);

AppInst_ReturnCode_t
AppInst_ObservableScope_delete_object(
		AppInst_ObservableScope *self,
		AppInst_ObservableObject *obj);

const AppInst_ObservableObject**
AppInst_ObservableScope_get_observable_objects(
		AppInst_ObservableScope *self,
		AppInst_INT32_t *result_len_out);

AppInst_ObservableObject*
AppInst_ObservableScope_lookup_object(
		AppInst_ObservableScope *self,
		const AppInst_STRING8_t name,
		AppInst_ReturnCode_t *retcode_out);

/* ------------------------------------------
 ObservableObject
 ------------------------------------------ */
const AppInst_STRING8_t
AppInst_ObservableObject_get_name(
		AppInst_ObservableObject *self);

AppInst_ObservableScope*
AppInst_ObservableObject_get_observable_scope(
		AppInst_ObservableObject *self);

AppInst_ObservableSchema*
AppInst_ObservableObject_get_observable_schema(
		AppInst_ObservableObject *self);

const AppInst_Observation**
AppInst_ObservableObject_get_observation_history(
		AppInst_ObservableObject *self,
		AppInst_INT32_t *result_len_out);

AppInst_ReturnCode_t
AppInst_ObservableObject_remote_observation_from_history(
		AppInst_ObservableObject *self,
		AppInst_Observation *obsv);

AppInst_ReturnCode_t
AppInst_ObservableObject_save_observation(
		AppInst_ObservableObject *self);

AppInst_BOOL_t
AppInst_ObservableObject_is_save_observation_enabled(
		AppInst_ObservableObject *self);

AppInst_ReturnCode_t
AppInst_ObservableObject_enable_save_observation(
		AppInst_ObservableObject *self);

AppInst_ReturnCode_t
AppInst_ObservableObject_disable_save_observation(
		AppInst_ObservableObject *self);

AppInst_ReturnCode_t
AppInst_ObservableObject_attach_data_processor(
		AppInst_ObservableObject *self,
		AppInst_DataProcessor *processor);

AppInst_DataProcessor*
AppInst_ObservableObject_detach_data_processor(
		AppInst_ObservableObject *self,
		AppInst_ReturnCode_t *retcode_out);

AppInst_DataProcessor*
AppInst_ObservableObject_get_data_processor(
		AppInst_ObservableObject *self,
		AppInst_ReturnCode_t *retcode_out);

AppInst_ReturnCode_t
AppInst_ObservableObject_bind_value(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_DataValueSource value_source);

AppInst_BOOL_t
AppInst_ObservableObject_is_value_bound(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index);

AppInst_ReturnCode_t
AppInst_ObservableObject_unbind_value(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_BOOL(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_BOOL_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_OCTET(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_OCTET_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_INT16(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_INT16_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_INT32(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_INT32_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_INT64(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_INT64_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_UINT16(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_UINT16_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_UINT32(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_UINT32_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_UINT64(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_UINT64_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_FLOAT32(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_FLOAT32_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_FLOAT64(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_FLOAT64_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_FLOAT128(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_FLOAT128_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_CHAR8(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_CHAR8_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_STRING8(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_STRING8_t value);

#ifdef APPINST_ENABLE_WCHAR
AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_CHAR32(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_CHAR32_t value);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_STRING32(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_STRING32_t value);
#endif

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_BOOLSeq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_BOOLSeq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_OCTETSeq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_OCTETSeq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_INT16Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_INT16Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_INT32Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_INT32Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_INT64Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_INT64Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_UINT16Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_UINT16Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_UINT32Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_UINT32Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_UINT64Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_UINT64Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_FLOAT32Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_FLOAT32Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_FLOAT64Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_FLOAT64Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_FLOAT128Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_FLOAT128Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_CHAR8Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_CHAR8Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_STRING8Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_STRING8Seq_t value,
		AppInst_INT32_t value_len);

#ifdef APPINST_ENABLE_WCHAR
AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_CHAR32Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_CHAR32Seq_t value,
		AppInst_INT32_t value_len);

AppInst_ReturnCode_t
AppInst_ObservableObject_set_value_STRING32Seq(
		AppInst_ObservableObject *self,
		AppInst_INT32_t field_index,
		AppInst_STRING32Seq_t value,
		AppInst_INT32_t value_len);
#endif

/* ------------------------------------------
 DataProcessor
 ------------------------------------------ */
const AppInst_STRING8_t
AppInst_DataProcessor_get_name(
		AppInst_DataProcessor *self);


#endif /* APPINST_DATA_COLLECTION_H_ */
