#ifndef APPINST_DATA_TYPES_H_
#define APPINST_DATA_TYPES_H_

/* ------------------------------------------
 DataValueKind
 ------------------------------------------ */

#ifndef APPINST_ENABLE_WCHAR
enum AppInst_DataValueKind {
	APPINST_TYPE_BOOL,
	APPINST_TYPE_OCTET,
	APPINST_TYPE_INT16,
	APPINST_TYPE_INT32,
	APPINST_TYPE_INT64,
	APPINST_TYPE_UINT16,
	APPINST_TYPE_UINT32,
	APPINST_TYPE_UINT64,
	APPINST_TYPE_FLOAT32,
	APPINST_TYPE_FLOAT64,
	APPINST_TYPE_FLOAT128,
	APPINST_TYPE_CHAR8,
	APPINST_TYPE_STRING8,
	APPINST_TYPE_BOOL_SEQ,
	APPINST_TYPE_OCTET_SEQ,
	APPINST_TYPE_INT16_SEQ,
	APPINST_TYPE_INT32_SEQ,
	APPINST_TYPE_INT64_SEQ,
	APPINST_TYPE_UINT16_SEQ,
	APPINST_TYPE_UINT32_SEQ,
	APPINST_TYPE_UINT64_SEQ,
	APPINST_TYPE_FLOAT32_SEQ,
	APPINST_TYPE_FLOAT64_SEQ,
	APPINST_TYPE_FLOAT128_SEQ,
	APPINST_TYPE_CHAR8_SEQ,
	APPINST_TYPE_STRING8_SEQ
};
#else
enum AppInst_DataValueKind {
	APPINST_TYPE_BOOL,
	APPINST_TYPE_OCTET,
	APPINST_TYPE_INT16,
	APPINST_TYPE_INT32,
	APPINST_TYPE_INT64,
	APPINST_TYPE_UINT16,
	APPINST_TYPE_UINT32,
	APPINST_TYPE_UINT64,
	APPINST_TYPE_FLOAT32,
	APPINST_TYPE_FLOAT64,
	APPINST_TYPE_FLOAT128,
	APPINST_TYPE_CHAR8,
	APPINST_TYPE_CHAR32,
	APPINST_TYPE_STRING8,
	APPINST_TYPE_STRING32,
	APPINST_TYPE_BOOL_SEQ,
	APPINST_TYPE_OCTET_SEQ,
	APPINST_TYPE_INT16_SEQ,
	APPINST_TYPE_INT32_SEQ,
	APPINST_TYPE_INT64_SEQ,
	APPINST_TYPE_UINT16_SEQ,
	APPINST_TYPE_UINT32_SEQ,
	APPINST_TYPE_UINT64_SEQ,
	APPINST_TYPE_FLOAT32_SEQ,
	APPINST_TYPE_FLOAT64_SEQ,
	APPINST_TYPE_FLOAT128_SEQ,
	APPINST_TYPE_CHAR8_SEQ,
	APPINST_TYPE_CHAR32_SEQ,
	APPINST_TYPE_STRING8_SEQ,
	APPINST_TYPE_STRING32_SEQ
};
#endif


/* ------------------------------------------
 BOOL
 ------------------------------------------ */
#define APPINST_BOOL_TRUE				(0)
#define APPINST_BOOL_FALSE				(1)

/* ------------------------------------------
 ReturnCode
 ------------------------------------------ */
enum AppInst_ReturnCode {
	APPINST_RETCODE_OK,
	APPINST_RETCODE_ERROR,
	APPINST_RETCODE_BAD_PARAMETER,
	APPINST_RETCODE_PRECONDITION_NOT_MET,
	APPINST_RETCODE_NOT_MODIFIED
};

/* ------------------------------------------
 Time
 ------------------------------------------ */
struct AppInst_Time {
	AppInst_INT32_t seconds;
	AppInst_UINT32_t nanoseconds;
};

#define APPINST_TIME_INITIALIZER { -1, 0 }

#define APPINST_TIME_ZERO { 0, 0 }

/* ------------------------------------------
 UTCTime
 ------------------------------------------ */
struct AppInst_UTCTime {
	AppInst_INT32_t seconds;
	AppInst_UINT32_t nanoseconds;
};

#define APPINST_UTCTIME_INITIALIZER { -1, 0 }

#endif /* APPINST_DATA_TYPES_H_ */
