#ifndef APPINST_INSTRUMENTATION_H_
#define APPINST_INSTRUMENTATION_H_

#include "appinst/appinst_defs.h"

/* ------------------------------------------
 InstrumentationService
 ------------------------------------------ */


const AppInst_STRING8_t APPINST_HOST_ID_AUTO = "APPINST_HOST_ID_AUTO";

AppInst_ReturnCode_t
AppInst_Infrastructure_init_instrumentation(
		const AppInst_STRING8_t host_id);

AppInst_ReturnCode_t
AppInst_Infrastructure_finalize_instrumentation();

const AppInst_STRING8_t
AppInst_Infrastructure_get_host_id();

AppInst_InstrumentationService*
AppInst_Infrastructure_create_service(
		const AppInst_STRING8_t name,
		const AppInst_InstrumentationServiceProperties_t *properties,
		AppInst_ReturnCode_t *retcode_out);

AppInst_ReturnCode_t
AppInst_Infrastructure_delete_service(
		AppInst_InstrumentationService *service);

AppInst_InstrumentationService*
AppInst_Infrastructure_lookup_service(
		const AppInst_STRING8_t name,
		AppInst_ReturnCode_t *retcode_out);

const AppInst_InstrumentationService**
AppInst_Infrastructure_get_services(
		AppInst_INT32_t *result_len_out);

const AppInst_STRING8_t
AppInst_InstrumentationService_get_name(
		AppInst_InstrumentationService *self);

AppInst_ObservableSchema*
AppInst_InstrumentationService_create_observable_schema(
		AppInst_InstrumentationService *self,
		const AppInst_STRING8_t name,
		const AppInst_ObservableSchemaProperties_t *properties,
		AppInst_ReturnCode_t *retcode_out);

AppInst_ReturnCode_t
AppInst_InstrumentationService_delete_observable_schema(
		AppInst_InstrumentationService *self,
		AppInst_ObservableSchema *schema);

const AppInst_ObservableSchema**
AppInst_InstrumentationService_get_observable_schemas(
		AppInst_InstrumentationService *self,
		AppInst_INT32_t *result_len_out);

AppInst_ObservableSchema*
AppInst_InstrumentationService_lookup_observable_schema(
		AppInst_InstrumentationService *self,
		const AppInst_STRING8_t name,
		AppInst_ReturnCode_t *retcode_out);

AppInst_ObservableScope*
AppInst_InstrumentationService_create_observable_scope(
		AppInst_InstrumentationService *self,
		const AppInst_STRING8_t name,
		const AppInst_ObservableScopeProperties_t *properties,
		AppInst_ReturnCode_t *retcode_out);

AppInst_ReturnCode_t
AppInst_InstrumentationService_delete_observable_scope(
		AppInst_InstrumentationService *self,
		AppInst_ObservableScope *scope);

const AppInst_ObservableScope**
AppInst_InstrumentationService_get_observable_scopes(
		AppInst_InstrumentationService *self,
		AppInst_INT32_t *result_len_out);

AppInst_ObservableScope*
AppInst_InstrumentationService_lookup_observable_scope(
		AppInst_InstrumentationService *self,
		const AppInst_STRING8_t name,
		AppInst_ReturnCode_t *retcode_out);

AppInst_DataProcessor*
AppInst_InstrumentationService_create_data_processor(
		AppInst_InstrumentationService *self,
		const AppInst_STRING8_t name,
		const AppInst_DataProcessorProperties_t *properties,
		AppInst_ReturnCode_t *retcode_out);

AppInst_ReturnCode_t
AppInst_InstrumentationService_delete_data_processor(
		AppInst_InstrumentationService *self,
		AppInst_DataProcessor *processor);

const AppInst_DataProcessor**
AppInst_InstrumentationService_get_data_processors(
		AppInst_InstrumentationService *self,
		AppInst_INT32_t *result_len_out);

AppInst_DataProcessor*
AppInst_InstrumentationService_lookup_data_processor(
		AppInst_InstrumentationService *self,
		const AppInst_STRING8_t name,
		AppInst_ReturnCode_t *retcode_out);


#endif /* APPINST_INSTRUMENTATION_H_ */
